package codechicken.enderstorage.internal;

import net.minecraftforge.common.MinecraftForge;
import codechicken.core.CommonUtils;
import codechicken.lib.packet.PacketCustom;
import codechicken.enderstorage.api.EnderStorageManager.EnderStoragePlayerTracker;
import codechicken.enderstorage.api.EnderStorageManager.EnderStorageSaveHandler;
import codechicken.enderstorage.common.BlockEnderStorage;
import codechicken.enderstorage.common.EnderStorageRecipe;
import codechicken.enderstorage.common.ItemEnderStorage;
import codechicken.enderstorage.storage.item.ItemEnderPouch;
import codechicken.enderstorage.storage.item.TileEnderChest;
import codechicken.enderstorage.storage.liquid.TankSynchroniser;
import codechicken.enderstorage.storage.liquid.TileEnderTank;
import cpw.mods.fml.common.registry.GameRegistry;
import cpw.mods.fml.common.registry.TickRegistry;
import cpw.mods.fml.relauncher.Side;

import static codechicken.enderstorage.EnderStorage.*;

public class EnderStorageProxy
{    
    public void init()
    {
        blockEnderChest = new BlockEnderStorage(config.getTag("block.id").getIntValue(CommonUtils.getFreeBlockID(241)));
        blockEnderChest.setUnlocalizedName("enderchest");
        GameRegistry.registerBlock(blockEnderChest, ItemEnderStorage.class, "enderChest");
        MinecraftForge.EVENT_BUS.register(blockEnderChest);
        
        itemEnderPouch = new ItemEnderPouch(config.getTag("pouch.id").getIntValue(7237));
        itemEnderPouch.setUnlocalizedName("enderpouch");
        
        GameRegistry.registerTileEntity(TileEnderChest.class, "Ender Chest");
        GameRegistry.registerTileEntity(TileEnderTank.class, "Ender Tank");
        
        PacketCustom.assignHandler(EnderStorageSPH.channel, 0, 255, new EnderStorageSPH());
        EnderStorageRecipe.init();
        
        GameRegistry.registerPlayerTracker(new EnderStoragePlayerTracker());
        GameRegistry.registerPlayerTracker(new TankSynchroniser());
        TickRegistry.registerTickHandler(new TankSynchroniser(), Side.SERVER);
    }

    public void preInit()
    {
        MinecraftForge.EVENT_BUS.register(new EnderStorageRecipe());
        MinecraftForge.EVENT_BUS.register(new EnderStorageSaveHandler());
        MinecraftForge.EVENT_BUS.register(new TankSynchroniser());
    }
}
